import java.io.*;

public class TestRead {
    public static void main(String args[]) {
	RK_proc_cpu_reader r = new RK_proc_cpu_reader(args[0]);
	try {
	    r.read();
	    System.out.println("enf_mode("+r.enf_mode+") rep_mode("+r.rep_mode+")");
	    System.out.println("reserved("+r.reserved+") utilized("+r.utilized+")");
	} catch (IOException e) {
	    System.out.println("Failed to read: " + args[0]);
	}
    }
}

class RK_proc_rs_reader {
    String path;
    
    RK_proc_rs_reader(String f) {
	path = f;
    }

    public int[] read()
	throws IOException
    {
	int n = 0;
	String lines[] = new String[256];
	
	BufferedReader in = new BufferedReader(new FileReader(path));
	try {
	    String line;
	    while((line = in.readLine()) != null) {
		System.out.println(line);
		lines[n++] = line;
	    }
	} catch (IOException e) {}
	in.close();

	int id[] = new int[n];
	for (int i = 0; i < n; i++) {
	    id[i] = (Integer.valueOf(lines[i], 16)).intValue();
	}
	return id;
    }
}

class RK_proc_cpu_reader {
    String	path;
    public int	enf_mode, rep_mode;
    public double	reserved, utilized;

    RK_proc_cpu_reader(String f) {
	path = f;
    }

    public void read()
	throws IOException
    {
	BufferedReader in = new BufferedReader(new FileReader(path));
	try {
	    String line;
	    int i, j;

	    // 1st line: enf_mode, rep_mode
	    line = in.readLine();
	    // System.out.println(line);
	    i = line.indexOf(' ');
	    enf_mode = (Integer.valueOf(line.substring(0, i))).intValue();
	    rep_mode = (Integer.valueOf(line.substring(i+1))).intValue();

	    // 2nd line: reserved utilized
	    line = in.readLine();
	    // System.out.println(line);
	    i = line.indexOf(' ');
	    reserved = (Double.valueOf(line.substring(0, i))).doubleValue();
	    i++;	// skip SPACE
	    j = line.indexOf(' ', i);
	    utilized = (Double.valueOf(line.substring(i, j))).doubleValue();
	} catch (IOException e) {}
	in.close();
    }
}
