#include <rk/rk_linux.h>
#include <rk/rk.h>

extern void	rk_reserve_init(void);
extern void	rk_resource_set_init(void);
extern void	rk_timer_init(void);
extern void	rk_proc_init(void);

cpu_tick_data_t	rk_cpu_ticks_per_second;
cpu_tick_data_t	rk_cpu_ticks_per_jiffy;

#ifdef	linux
void
rk_cpu_calibration(void)
{
	printk("rk_cpu_calibration: Calibrating cpu ");
	{
		cpu_tick_data_t	begin, end;
		unsigned long	first_jiffies;
		int		i = 5;

		/* wait for "start of" clock tick */
		first_jiffies = jiffies;
		while (first_jiffies == jiffies) {
			/* nothing */
		}
		rk_rdtsc(&begin);
		while (i-- > 0) {
			first_jiffies = jiffies;
			printk(".");
			while (jiffies - first_jiffies < HZ) {
				/* nothing */
			}
		}
		rk_rdtsc(&end);
		/* */
		rk_cpu_ticks_per_second = (end-begin)/5;
		{
			cpu_tick_data_t	ns = RK_NANOSECS_PER_JIFFY;
			nanosec2tick(&ns, &rk_cpu_ticks_per_jiffy);
		}
		/* */
		rk_cpu_tick_at_boot = end - rk_cpu_ticks_per_jiffy*jiffies;
	}
	printk(" %lu cycles per second.\n", (unsigned long)rk_cpu_ticks_per_second);
}
#endif

void
rk_init(void)
{
	rk_reserve_init();
	rk_resource_set_init();
	rk_timer_init();
#ifdef	linux
	rk_cpu_calibration();
	rk_proc_init();
#endif
}
